using ShoeStore.Repositories.Implementations;
using ShoeStore.Repositories;
using Unity.Lifetime;
using Unity;

namespace ShoeStore
{
    internal static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            // To customize application configuration such as set high DPI settings or default font,
            // see https://aka.ms/applicationconfiguration.
            ApplicationConfiguration.Initialize();
            Application.Run(CreateContainer().Resolve<FormStorage>());
        }
        private static IUnityContainer CreateContainer()
        {
            var container = new UnityContainer();
            container.RegisterType<IFactoryRepository,
            FactoryRepository>(new TransientLifetimeManager());
            container.RegisterType<IStoreRepository,
            StoreRepository>(new TransientLifetimeManager());
            container.RegisterType<IShoesRepository, ShoesRepository>(new
            TransientLifetimeManager());
            container.RegisterType<IShoesSaleRepository,
            ShoesSaleRepository>(new TransientLifetimeManager());
            container.RegisterType<IShoesReplenishmentRepository,
            ShoesReplenishmentRepository>(new TransientLifetimeManager());
            return container;
        }
    }
}
